// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIEncryptionType.h"
#import <Foundation/Foundation.h>
@class VFIAdeEncryption;

/**
 *Encryption Options bit mapped flags passed as hex strings:
 *Data padding with 0x00: XX XX XX XX 00 00 00 00
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONDATAPADDING00;
/**Data padding with 0xff: XX XX XX XX ff ff ff ff */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONDATAPADDINGFF;
/**Truncate PAN (TLV tag 5A): 123456789FFFF =&gt; 123456789F */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRUNCATEPAN;
/**Add empty tags (with length 0) to result */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONADDEMPTYTAGS;
/**Truncate values if data exceeds the fixed length */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRUNCATE;
/**
 *Use the associated value only, without tag or length information.  Not allowed if requesting
 *more than one tag and one or more tags are requested as variable length.
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONVALUEONLY;
/**
 *Format MSR Track 2 (TLV tag 57) according to the EMV Track 2 Equivalent Data spec.
 *For CT and CTLS, this has no effect as they are already in the expected EMV format.
 *When not used with MSR, Track2 will contain start and end sentinels and LRC.
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRACK2EMV;
/**
 *Format CVV as an ASCII string with no padding and no null terminator.
 *When not used, CVV will be in BCD, with trailing F for odd length values
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONCVVASCII;
/**
 *Format PAN as an ASCII string with no padding and no null terminator.
 *When not used, PAN will be in BCD, with trailing F for odd length values
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONPANASCII;
/**
 *Format Track 2 as an ASCII string with no padding and no null terminator.
 *When not used, Track2 will be in BCD, with trailing F for odd length values
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRACK2ASCII;
/**Format Expiry Date (TLV tag 5F24) as an ASCII string with no padding */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONEXPIRYASCII;
/**
 *Format Track 2 as an ASCII string according to MSR spec with start ';' and end '?' sentinels
 *but with no LRC or padding
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRACK2ASCIIMSR;
/**
 *Format Track1 equivalent data (TLV tag 56) according the EMV Track 1 Equivalent Data spec.
 *For CT and CTLS, this has no effect as they are already in the expected EMV format.
 *When not used with MSR, Track1 will contain start and end sentinels and LRC.
 */
extern NSString * __nonnull const VFIAdeEncryptionENCRYPTIONOPTIONTRACK1EMV;

/**
 * Allows an application to specify how to encrypt either sensitive card
 * information or an entire message for the retrieved ADE encrypted message.
 */
@interface VFIAdeEncryption : NSObject

+ (nullable VFIAdeEncryption *)create;

/**Set encryption mode to either data encryption or message encryption */
- (void)setEncryptionMode:(VFIEncryptionType)mode;

/**Set name of crypto interface */
- (void)setCryptoInterface:(nonnull NSString *)name;

/**Set hex message to be inserted into EncryptMessage container */
- (void)setHexMessageField:(nonnull NSData *)value;

/**Set text message to be inserted into EncryptMessage container */
- (void)setTextMessageField:(nonnull NSString *)value;

/** Add TLV values and lengths for EncryptData TLV data */
- (void)addEncryptDataTags:(nonnull NSString *)value
                    length:(int32_t)length;

/** Set Data Options for EncryptData TLV data */
- (void)setEncryptDataOptions:(nonnull NSString *)options;

/** Add positional tag values and lengths for EncryptMessage sensitive data */
- (void)addEncryptMessageTags:(nonnull NSString *)value
                       length:(int32_t)length
                      options:(nonnull NSString *)options
                     position:(int32_t)position;

/** Specify the key to use as hex string */
- (void)setKeySetId:(nonnull NSString *)id;

/**Set initialization vector as hex string */
- (void)setInitializationVector:(nullable NSString *)iv;

@end
